//
//  FlipView.m
//  mySubTest
//
//  Created by wangchan on 16/4/14.
//  Copyright © 2016年 Koala. All rights reserved.
//

#import "FlipView.h"

@interface FlipView ()

@property(nonatomic)BOOL goingToFrontView;

@end


@implementation FlipView
-(instancetype)initWithFrame:(CGRect)frame
{
    if (self=[super initWithFrame:frame]) {
        self.backView.backgroundColor=[UIColor whiteColor];
        self.frontView.backgroundColor=[UIColor whiteColor];
        self.goingToFrontView=NO;
    }
    return self;
}
-(void)setFrontView:(UIView *)frontView
{
    if (!_frontView) {
        _frontView=frontView;
        [self addSubview:frontView];
        [self bringSubviewToFront:self.frontView];
    }
}
-(void)setBackView:(UIView *)backView
{
    if (!_backView) {
        _backView=backView;
        [self addSubview:backView];
        [self bringSubviewToFront:self.frontView];
    }
}
-(void)setIsBeginFlip:(BOOL)isBeginFlip
{
    self.goingToFrontView = !self.goingToFrontView;
    UIViewAnimationOptions transitionDirection=[self getSelfFlipDirection];
    
    UIView *fromView = self.goingToFrontView ? self.frontView : self.backView;
    UIView *toView = self.goingToFrontView ? self.backView : self.frontView;

    [UIView transitionFromView:fromView
                        toView:toView
                      duration:1.0
                       options:transitionDirection
                    completion:^(BOOL finished) {
                        
                    }];
}
-(void)setFlipType:(ViewFlipType)flipType
{
    _flipType=flipType;
}
//翻转方向
-(UIViewAnimationOptions)getSelfFlipDirection
{
    if (self.flipType==ViewFlipTypeTopAndBottom) {
        return self.goingToFrontView ? UIViewAnimationOptionTransitionFlipFromTop : UIViewAnimationOptionTransitionFlipFromBottom;
    }else if (self.flipType==ViewFlipTypeCurlUpAndDown)
    {
        return self.goingToFrontView?UIViewAnimationOptionTransitionCurlUp:UIViewAnimationOptionTransitionCurlDown;
    }
    return self.goingToFrontView ? UIViewAnimationOptionTransitionFlipFromLeft : UIViewAnimationOptionTransitionFlipFromRight;
}
@end
